forum/urls.py
from django.urls import path
from .views import *

urlpatterns = [
    path('', index, name='index'),
]

project_pbp/urls.py
from django.contrib import admin
from django.urls import path, include
import swabIn.urls as swabIn
import user.urls as user

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(swabIn)),
    path('', include(user)),
]

swabIn/urls.py
from django.urls import path
from .views import index

urlpatterns = [
    path('', index, name='index'),
]

user/urls.py
from django.urls import path, include
from .views import *

urlpatterns = [
    path('login/', Userlogin, name='login'),
    path('auth/', authenticate_login, name='auth'),
    path('logout/', Userlogout, name='logout'),
    path('register/', UserRegister, name='register'),
]

forum/models.py
from django.db import models

# Create your models here.

swabIn/models.py
from django.db import models

# Create your models here.

user/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

# Create your models here.
# class UserProfile(models.Model):
#     name = models.CharField(max_length=100)
#     username = models.CharField(max_length=100)
#     email = models.EmailField(max_length=100)
#     pekerjaan = models.CharField(max_length=50)
#     umur = models.CharField(max_length=30)
#     password = models.CharField(max_length=20)
#     re_password = models.CharField(max_length=20)

# class UserProfile(User):
#     pekerjaan = models.CharField(max_length=50, default='DEFAULT VALUE')
#     umur = models.CharField(max_length=30, default='DEFAULT VALUE')


class CustomUser(User):
    pekerjaan = models.CharField(max_length=50)
    umur = models.CharField(max_length=30)

user/forms.py
from django import forms
# from django.contrib.auth.models import UserProfile
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import authenticate
from user.models import CustomUser

# class UserRegistrationForm(forms.ModelForm):
#     # name = forms.CharField(max_length=100, required=True)
#     # username = forms.CharField(max_length=100, required=True)
#     # email = forms.EmailField(max_length=100, required=True)
#     # pekerjaan = forms.CharField(max_length=50, required=True)
#     # umur = forms.CharField(max_length=30, required=True)
#     # tanggal_lahir = forms.DateField(required=True)
#     # password = forms.CharField(max_length=20, required=True, widget= forms.PasswordInput)
#     # re_password = forms.CharField(max_length=20, required=True)
#     class Meta:
#         model = UserProfile
#         # model = User
#         fields = "__all__"


class UserRegistrationForm(UserCreationForm):

    email = forms.EmailField(required=True)

    class Meta:
        model = CustomUser
        fields = ("first_name", "username", "email",
                  "pekerjaan", "umur", "password1", "password2")

    def save(self, commit=True):
        user = super(UserRegistrationForm, self).save(commit=False)
        user.email = self.cleaned_data['email']
        if commit:
            user.save()
        return user

class UserAuthenticationForm(UserCreationForm):
    password = forms.CharField(label="password", widget=forms.PasswordInput)

    class Meta:
        model = CustomUser
        fields = ('email', 'password',)
        
    def clean(self):
        if self.is_valid():
            username = self.cleaned_data['username']
            password = self.cleaned_data['password']
            if not authenticate(username=username, password=password):
                raise forms.ValidationError("Invalid Login")


# class UserLoginForm(forms.ModelForm):
#     class Meta:
#         # model = User
#         model = UserProfile
#         fields = "username", "password"
#         widgets = {
#             'username' : forms.widgets.TextInput(attrs={'placeholder':'username anda'}),
#             'password' : forms.widgets.TextInput(attrs={'placeholder':'masukkan password'}),
#         }

#         help_texts = {
#             'username': None,
#         }

#         labels = {'username' : 'Username', 'password' : 'Password'}

forum/views.py
from django.shortcuts import render

# Create your views here.

swabIn/views.py
from django.shortcuts import render
from django.http import HttpResponse

# Create your views here.
def index(request):
    return render(request, 'swabIn/index.html')

user/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
# from django.contrib.auth.models import UserProfile
from user.models import CustomUser
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.forms import AuthenticationForm
# Create your views here.
from .forms import UserRegistrationForm, UserAuthenticationForm
from django.contrib import messages
from django.http import JsonResponse
import json

# def Userlogin(request):
#     form = UserLoginForm()
#     data = {
#         'form':form,
#     }
#     if request.method == 'POST':
#         username = request.POST.get('username')
#         password = request.POST.get('password')
#         print(username, password)
#         user = authenticate(request,username=username, password=password)

#         if user is not None:
#             login(request, user)
#             return JsonResponse({"status":"User Login Success"})
#             # return redirect('Landing Page')
#         else:
#             return JsonResponse({"status":"Invalid Credential"})


def Userlogout(request):
    logout(request)
    messages.info(request, "You have successfully logged out.")
    return redirect("/")


def Userlogin(request):
    if request.user.is_authenticated:
        return redirect("/")

    return render(request, "login.html")


def authenticate_login(request):
    response = {}
    response['status'] = "Invalid Credential"
    form = AuthenticationForm(request, data=request.POST)
    if request.method == "POST":
        if form.is_valid():
            username = form.cleaned_data.get('username')
            password = form.cleaned_data.get('password')
            user = authenticate(username=username, password=password)
            if user is not None:
                login(request, user)
                messages.success(request, 'User Login Success!')
                response['status'] = "User Login Success"
        else:
            response['status'] = "Invalid Credential"

    return JsonResponse(response)


def UserRegister(request):
    response = {}
    if request.user.is_authenticated:
        return redirect("/")
    if request.method == "POST":
        form = UserRegistrationForm(request.POST)
        password = request.POST.get('password1')
        re_password = request.POST.get('password2')

        if form.is_valid():
            print(form)
            user = form.save()
            login(request, user)
            messages.success(request, 'Selamat user berhasil dibuat!')
            return redirect('/')

        if(password != re_password):
            response['message'] = 'Password tidak cocok.'

    return render(request, 'register.html', response)

forum/templates/forum/index.html
{% extends 'base.html' %}
{% load static %}

{% block title %}
Forum
{% endblock title %}
{% block content %}
<div>
    Ini Forum
</div>
{% endblock content %}

swabIn/templates/swabIn/index.html
{% extends 'base.html' %}
{% load static %}

{% block title %}
Swab.In
{% endblock title %}
{% block content %}

{% if messages %}
  <ul class="messages">
    {% for message in messages %}
    <li id="error_text" {% if message.tags %} class="text-{{ message.tags }}" {% endif %}> 
      {{ message }} </li>
    {% endfor %}
  </ul>
{% endif %}
<div>
    Hello World!
</div>

<button class='btn1'>
    Click
</button>
{% endblock content %}

{% block js %}
<script src="{% static 'js/function.js' %}"></script>
{% endblock js %}

templates/base.html
<!doctype html>
<html lang="en">
{% load static %}

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link
        href="https://fonts.googleapis.com/css2?family=Poppins:ital,wght@0,400;0,500;0,700;1,400;1,500;1,700&display=swap"
        rel="stylesheet">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="{% static 'styles/navbar.css' %}" />
    {% block css %}
    {% endblock css %}
    <title>{%block title %} {% endblock title %}</title>
</head>

<body>
    {% include 'navbar.html' %}
    <div>
        <h1>Hello, world!</h1>
        {% block content %}
        {% endblock content %}
    </div>
</body>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p"
    crossorigin="anonymous"></script>
<script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk="
    crossorigin="anonymous"></script>
{% block js %}
{% endblock js %}

</html>

templates/navbar.html
{% load static %}

<nav>
    <div class="d-flex flex-col justify-content-between align-items-center">
        <div class="d-flex flex-col align-items-center">
            <img src="{% static 'images/logo.svg' %}" alt="logo swabIn">
            <h3>Swab.In</h3>
        </div>
        <div class="d-flex flex-col align-items-center">
            <div class="opt">
                Swab & Vaksin
            </div>
            <div class="opt">
                About
            </div>
            <div class="opt">
                Lokasi
            </div>
            <div class="opt">   
                Artikel
            </div>
            <div class="login-btn">
                <a href="login/" > LOGIN </a>
            </div>
        </div>
    </div>

</nav>

user/templates/login.html
{%  load static  %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" 
    rel="stylesheet" integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}">
    <title>Login Page</title>
</head>
<body>
  <!-- {% if messages %}
  <ul class="messages">
    {% for message in messages %}
    <li id="error_text" {% if message.tags %} class="text-{{ message.tags }}" {% endif %}> 
      {{ message }} </li>
    {% endfor %}
  </ul>
  {% endif %} -->
    <div class="container">
        <div class="row">
            <header>
                <div class="row">
                    <div class="logo-row">
                            <img src="{% static 'images/logo.svg' %}" alt="logo swabIn" width="70" height="85">
                            <h3>Swab.In</h3>
                        <!-- </div> -->
                    </div>
                </div>
              </header>
          <div class="col-sm-9 col-md-7 col-lg-5 mx-auto">
            <div class="card border-0 shadow rounded-3 my-5">
              <div class="card-body p-4 p-sm-5">
                <form id="loginForm">
                  <p id="error-message"></p>
                  <!-- <p id="message" class="text-white"></p> -->
                  {% csrf_token %}
                  <div class="form-floating mb-3">
                    <input type="username" id="username" class="form-control"  placeholder="username" name="username" required>
                    <label for="floatingInput">Username</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input type="password" id="password" class="form-control" placeholder="Password" name="password" required>
                    <label for="floatingPassword">Password</label>
                  </div>
    
                  <div class="form-check mb-3">
                    <input class="form-check-input" type="checkbox" value="" id="rememberPasswordCheck">
                    <label class="form-check-label" for="rememberPasswordCheck">
                      Remember password
                    </label>
                  </div>
                  <div class="d-grid">
                    <button class="btn btn-primary btn-login fw-bold" type="button" id="loginButton" onclick="login()">Login</button>
                  </div>
                  <br>
                  <div class="row mb-2 px-6"> <small class="font-weight-bold">Belum punya akun? <a href="/register/">Register</a></small> </div>
                  <hr class="my-4">
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
</body>
      <script src="https://code.jquery.com/jquery-3.5.1.js"
      integrity="sha256-QWo7LDvxbWT2tbbQ97B53yJnYU3WhH/C8ycbRAkjPDc=" crossorigin="anonymous"></script>
      <script> 
          function login() {
              var username = $('#username').val()
              var password = $('#password').val()
              $.ajax({                                                                                                                           
                type:"POST",                                                                                                                    
                url: '/auth/',                                                                                                   
                data: $('#loginForm').serialize(),                                                               
                success: function(response){ 
                  if (response.status === "User Login Success") {
                    location.href = "/";
                  } else {
                    $('#error-message').text(response.status);
                  }
                }                                                                                                                             
            });
          }
        </script>
</html>

user/templates/register.html
{%  load static  %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" 
    rel="stylesheet" integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}">
    <title>Register Page</title>
</head>
<body>
    <div class="container">
      <!-- <p id="error" class="text-white"> </p> -->
        <div class="row">
            <header>
                <div class="row">
                    <div class="logo-row">
                        <!-- <div class="d-flex flex-col align-items-center"> -->
                            <img src="{% static 'images/logo.svg' %}" alt="logo swabIn" width="70" height="85">
                            <h3>Swab.In</h3>
                        <!-- </div> -->
                    </div>
                </div>
              </header>
          <div class="col-sm-9 col-md-7 col-lg-5 mx-auto">
            <div class="card border-0 shadow rounded-3 my-5">
              <div class="card-body p-4 p-sm-5">
                <form method="POST" action="{% url 'register' %}" id="registerForm">
                  {% csrf_token %}
                  <p>{{ message }}</p>
                    <div class="form-floating mb-3">
                        <input type="name" class="form-control"  placeholder="your name" name="first_name" required>
                        <label for="floatingInput">Name</label>
                      </div>
                  <div class="form-floating mb-3">
                    <input type="username" class="form-control"  placeholder="username" name="username" required>
                    <label for="floatingInput">Username</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input type="email" class="form-control"  placeholder="name@example.com" name="email" required>
                    <label for="floatingInput">Email</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input type="pekerjaan" class="form-control"  placeholder="pekerjaan kamu" name="pekerjaan" required>
                    <label for="floatingInput">Pekerjaan</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input type="umur" class="form-control"  placeholder="umur kamu" name="umur" required>
                    <label for="floatingInput">Umur</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input type="password" class="form-control" placeholder="Password" name="password1" required>
                    <label for="floatingPassword">Password</label>
                  </div>
                  <div class="form-floating mb-3">
                    <input type="password" class="form-control" placeholder="Repeat your password" name="password2" required>
                    <label for="floatingPassword">Re Password</label>
                  </div>
                  <div class="d-grid">
                    <input class="btn btn-primary btn-login fw-bold" type="submit" value="Register">
                  </div>
                  <br>
                  <div class="row mb-2 px-6"> <small class="font-weight-bold">Sudah punya akun? <a href="/login/">Login</a></small> </div>
                  <hr class="my-4">
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
</body>
<script src="https://code.jquery.com/jquery-3.5.1.js"
        integrity="sha256-QWo7LDvxbWT2tbbQ97B53yJnYU3WhH/C8ycbRAkjPDc=" crossorigin="anonymous"></script>
        <script> 
                $(document).on('submit', 'registerForm', function(e){
                    e.preventDefault();
                    var name = $('#id_name').val()
                    var username = $('#id_username').val()
                    var email = $('#id_email').val()
                    var pekerjaan = $('#id_pekerjaan').val()
                    var umur = $('#id_umur').val()
                    var password = $('#id_password').val()
                    var re_password = $('#id_re_password').val()
                    
                    // ajax call
                    $.ajax({
                        type: 'POST',
                        url: 'register/',
                        data:{
                            first_name :name,
                            username :username,
                            email :email,
                            pekerjaan :pekerjaan,
                            umur :umur,
                            password1 :password,
                            password2 :re_password,
                            csrfmiddlewaretoken: $('input[name=csrfmiddlewaretoken]').val(),
                        },
                        success:function(response){
                            console.log(response)
                            var error = $(response).find('#error_text')
                            console.log(error);
                            var error_class = $(error).attr('class')
                            console.log(error_class);
                            console.log(error.text())
                            $('#error').addClass(error_class)
                            $('#error').text(error.text())
                            $('#message').addClass("p-2");
                            if(response.status == "Password tidak cocok"){
                                  $('message').addClass('bg-danger')
                            }
                        }
                    })
                })
        </script>

</html>